package com.liang.dao;

import com.liang.entity.PrjSubtopic;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * (PrjSubtopic)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-20 16:25:07
 */
public interface PrjSubtopicDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjSubtopic queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param prjSubtopic 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<PrjSubtopic> queryAllByLimit(PrjSubtopic prjSubtopic, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjSubtopic 查询条件
     * @return 总行数
     */
    long count(PrjSubtopic prjSubtopic);

    /**
     * 新增数据
     *
     * @param prjSubtopic 实例对象
     * @return 影响行数
     */
    int insert(PrjSubtopic prjSubtopic);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjSubtopic> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjSubtopic> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjSubtopic> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjSubtopic> entities);

    /**
     * 修改数据
     *
     * @param prjSubtopic 实例对象
     * @return 影响行数
     */
    int update(PrjSubtopic prjSubtopic);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取子课题列表
     *
     * @return
     */
    List<PrjSubtopic> getSubtopicList(Integer xm);

    /**
     * 批量删除子课题
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 通过项目删除数据
     *
     * @param xm
     * @return
     */
    int deleteByXm(Integer xm);

    /**
     * 批量删除子课题
     *
     * @param xmList
     * @return
     */
    int batchDeleteByXm(List<Integer> xmList);

    /**
     * 根据任务书id查询任务书的日期信息
     *
     * @param id 项目id
     * @return
     */
    List<Map<String, Object>> queryProjectDate(int id);
}

